function [Q,R] = hQR(A)
    % Descomposición QR con Householder
    N = size(A,1);
    Q = eye(N); % Q es el producto H_k...H_1
    R = A;
    for k = 1: N-1
        x = R(k:N,k); % columna k desde el elemento k
        v = zeros(N,1);
        v(k:N) = vh(x);
        % Esta es la matriz de Householder completada con
        % unos, que vienen de las primeras coordenadas 
        % nulas de v. Esto es Qt es NxN si A es cuadrada. 
        H = eye(N)-2*v*v'; 
    
        Q = H * Q;
        R = H * R;
    
        % Para que sea exactamente triangular
        R(k+1:N,k) = zeros(N-k,1);
        % Esto evita que en el caso de N muy grande
        % se acumulen errores. 
    end
    
    Q = Q';

end